package com.u6f6o.education.code_kata.prime_factors;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.*;

import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;
import com.u6f6o.education.code_kata.prime_factors.PrimeFactoryKata;

import java.util.Arrays;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: u6f6o
 * Date: 12/07/12
 * Time: 22:00
 * To change this template use File | Settings | File Templates.
 */
public class PrimeFactoryKataTest{
    public static final PrimeFactoryKata KATA = new PrimeFactoryKata();

    @DataProvider( name = "expected primes table" )
    private Object[][] createExpectedPrimesTable() {
        return new Object[][] {
            { 0, list( )},
            { 1, list( )},
            { 2, list( 2 )},
            { 3, list( 3 )},
            { 4, list( 2, 2 )},
            { 5, list( 5 )},
            { 6, list( 2, 3 )},
            { 7, list( 7 )},
            { 8, list( 2, 2, 2 )},
            { 9, list( 3, 3 )},
            { 60, list( 2, 2, 3, 5 )},
            { 74, list( 2, 37 )},
            { 2 * 3 * 5 * 5 * 7 * 11 * 23, list( 2, 3, 5, 5, 7, 11, 23 )},
            { 8191 * 131071, list( 8191, 131071 )},
            { (2 << 18) - 1, list( (2 << 18) - 1 )}
        };
    }

    @Test( dataProvider = "expected primes table" )
    public void testPrimeFactors( int number, List<Integer> expectedPrimes ) {
        List<Integer> primes = KATA.getPrimeFactors( number );
        assertThat( primes, is( equalTo( expectedPrimes )));
    }

    private List<Integer> list( Integer ... numbers ) {
        return Arrays.asList( numbers );
    }
}
